01 矩阵
给定一个由 0 和 1 组成的矩阵 mat ,请输出一个大小相同的矩阵,其中每一个格子是 mat 中对应位置元素到最近的 0 的距离。
两个相邻元素间的距离为 1 。
示例 1:
输入:mat = [[0,0,0],[0,1,0],[0,0,0]]
输出:[[0,0,0],[0,1,0],[0,0,0]]
示例 2:
输入:mat = [[0,0,0],[0,1,0],[1,1,1]]
输出:[[0,0,0],[0,1,0],[1,2,1]]
提示:
m == mat.length
n == mat[i].length
1 <= m, n <= 104
1 <= m * n <= 104
mat[i][j] is either 0 or 1.
mat 中至少有一个 0
来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/01-matrix
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
解题思路1
没有接触过多源最短路径的问题,由于求得是1到最近的0的距离,所以我的想法就是遍历每一个1,再计算1到最近的0的距离。常见的BFS的最短路径的求法是求到每一个点的最短距离并记录最短距离到矩阵中,并更新为已经访问,那么后面再也不会访问到了也就是最短的距离了。并不需要一层一层地遍历,我就是按一层一层来写的。虽然直到这种写法必然会超时,但是练习一下BFS也未尝不可。
code
class Solution {
public:
vector<vector<int>> updateMatrix(vector<vector<int>>& mat) {
int height = mat.size(),width = mat[0].size();
vector<vector<int>> ans(height , vector<int>(width,0));
int dx[4] = {-1,1,0,0};
int dy[4] = {0,0,-1,1};
for(int i = 0;i < height;i ++)
{
for(int j = 0;j < width;j ++)
{
if(mat[i][j] == 1)
{
queue<pair<int,int>> q;
vector<vector<int>> visit(height , vector<int>(width,0));
q.push({i,j});
int dis = 0;
dis ++;
visit[i][j] = 1;
while(!q.empty())
{
int cnt = q.size();
bool find = false;
for(int i = 0;i < cnt;i ++)
{
pair<int,int> cur = q.front();
q.pop();
for(int i = 0;i < 4;i ++)
{
int x = cur.first + dx[i];
int y = cur.second + dy[i];
if(x >= 0 && x < height && y >= 0 && y < width && !visit[x][y])
{
if(mat[x][y] == 0)
{
find = true;
break;
}
q.push({x,y});
visit[x][y] = 1;
}
}
}
if(find) break;
dis ++;
}
ans[i][j] = dis;
}
}
}
return ans;
}
};
解题思路2:多源BFS
题目中要求解的是1到零的最短距离,那么可否换一个思路,求解0到每一个1的最短距离。首先考虑只有一个零的情况,那么可以从该0出发,BFS遍历求解到每一个1的最短距离。如果有多个零,要求解到1的最短距离呢?可以添加一个超级源点,和所有的0相连,距离为0,由于距离为0,那么所有零到1的最短距离就是超级源点到1的最短距离,这样子就是相当于将所有的0看作一个整体,再求解到1的最短距离。第一步就是将超级源点加入队列中,并弹出,再将相连的0全部加入队列中即可。所以等价的第一步就是将所有的零加入队列中。
code
class Solution {
public:
vector<vector<int>> updateMatrix(vector<vector<int>>& mat) {
int height = mat.size(),width = mat[0].size();
vector<vector<int>> ans(height , vector<int>(width,0));
int dx[4] = {-1,1,0,0};
int dy[4] = {0,0,-1,1};
queue<pair<int,int>> q;
vector<vector<int>> visit(height,vector<int>(width,0));
for(int i = 0;i < height;i ++)
{
for(int j = 0;j < width;j ++)
{
if(mat[i][j] == 0)
{
q.push({i,j});
visit[i][j] = 1;
}
}
}
while(!q.empty())
{
pair<int,int> cur = q.front();
q.pop();
for(int i = 0;i < 4;i ++)
{
int x = cur.first + dx[i];
int y = cur.second + dy[i];
if(x >= 0 && x < height && y >= 0 && y < width && !visit[x][y])
{
q.push({x,y});
visit[x][y] = 1;
ans[x][y] = ans[cur.first][cur.second] + 1;
}
}
}
return ans;
}
};
标签:01,mat,int,矩阵,++,height,width,vector
From: https://www.cnblogs.com/huangxk23/p/17136771.html